--- ./openssl.c	2025-01-25 05:54:54
+++ ./openssl.c	2025-01-25 10:15:55
@@ -1537,10 +1537,18 @@
       goto exit;
    }
 #else
+#ifndef USE_EVP_PKEY_EC
    key = EVP_RSA_gen(RSA_KEYSIZE);
+#else  /* #ifndef USE_EVP_PKEY_EC */
+   key = EVP_EC_gen(EC_GROUP_NAME);
+#endif /* #ifndef USE_EVP_PKEY_EC */
    if (key == NULL)
    {
+#ifndef USE_EVP_PKEY_EC
       log_error(LOG_LEVEL_ERROR, "EVP_RSA_gen() failed");
+#else  /* #ifndef USE_EVP_PKEY_EC */
+      log_error(LOG_LEVEL_ERROR, "EVP_EC_gen() failed");
+#endif /* #ifndef USE_EVP_PKEY_EC */
       ret = -1;
       goto exit;
    }
